package br.ufrgs.inf.nangatelab.gui.resources;

import br.ufrgs.inf.nangatelab.util.io.ResourceLoader;
import java.awt.Image;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.swing.ImageIcon;

/**
 * A class to load common GUI resources.
 *
 * @author Carlos Eduardo Klock
 */
public final class CommonResources {

    private static CommonResources INSTANCE = null;

    private final ResourceLoader loader;

    private CommonResources() {
    	loader = new ResourceLoader(CommonResources.class);
    }

    public static CommonResources getInstance() {
        if (INSTANCE == null) {
            INSTANCE = new CommonResources();
        }
        return INSTANCE;
    }

    public final String loadStringEx(String path) {
        return loader.loadStringEx(path);
    }

    public final String loadString(String path, String charsetName) throws FileNotFoundException, IOException {
        return loader.loadString(path, charsetName);
    }

    public final String loadString(String path) throws FileNotFoundException, IOException {
        return loader.loadString(path);
    }

    public final ImageIcon loadImageIconWidthResizing(String path, int newWidth) {
        return loader.loadImageIconWidthResizing(path, newWidth);
    }

    public final ImageIcon loadImageIconHeightResizing(String path, int newHeight) {
        return loader.loadImageIconHeightResizing(path, newHeight);
    }

    public final ImageIcon loadImageIcon(String path, int width, int height) {
        return loader.loadImageIcon(path, width, height);
    }

    public final ImageIcon loadImageIcon(String path, int width, int height, int scalingAlgorithm) {
        return loader.loadImageIcon(path, width, height, scalingAlgorithm);
    }

    public final ImageIcon loadImageIcon(String path) {
        return loader.loadImageIcon(path);
    }

    public final Image loadImage(String path) {
        return loader.loadImage(path);
    }

}
