package br.ufrgs.inf.nangatelab.tools.logic2logic.help;

import br.ufrgs.inf.nangatelab.util.io.ResourceLoader;
import java.awt.Image;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import javax.swing.ImageIcon;

/**
 *
 * @author Carlos
 */
public final class Logic2LogicHelpLoader {

    private static Logic2LogicHelpLoader INSTANCE = null;

    private final ResourceLoader loader;

    private Logic2LogicHelpLoader() {
        loader = new ResourceLoader(Logic2LogicHelpLoader.class);
    }

    public static Logic2LogicHelpLoader getInstance() {
        if (INSTANCE == null) {
            INSTANCE = new Logic2LogicHelpLoader();
        }
        return INSTANCE;
    }

    public final String loadStringEx(String path) {
        return loader.loadStringEx(path);
    }

    public final String loadString(String path, String charsetName) throws FileNotFoundException, IOException {
        return loader.loadString(path, charsetName);
    }

    public final String loadString(String path) throws FileNotFoundException, IOException {
        return loader.loadString(path);
    }

    public final InputStream loadStream(String path) {
        return loader.loadStream(path);
    }

    public final Object loadObject(String path) throws IOException, ClassNotFoundException {
        return loader.loadObject(path);
    }

    public final ImageIcon loadImageIconWidthResizing(String path, int newWidth) {
        return loader.loadImageIconWidthResizing(path, newWidth);
    }

    public final ImageIcon loadImageIconHeightResizing(String path, int newHeight) {
        return loader.loadImageIconHeightResizing(path, newHeight);
    }

    public final ImageIcon loadImageIcon(String path, int width, int height) {
        return loader.loadImageIcon(path, width, height);
    }

    public final ImageIcon loadImageIcon(String path, int width, int height, int scalingAlgorithm) {
        return loader.loadImageIcon(path, width, height, scalingAlgorithm);
    }

    public final ImageIcon loadImageIcon(String path) {
        return loader.loadImageIcon(path);
    }

    public final Image loadImage(String path) {
        return loader.loadImage(path);
    }

    public final URL loadURL(String path) {
        return loader.loadURL(path);
    }

}
